package ru.bitel.mybgbilling.auth;

import java.io.IOException;

import jakarta.servlet.Filter;
import jakarta.servlet.FilterChain;
import jakarta.servlet.FilterConfig;
import jakarta.servlet.ServletException;
import jakarta.servlet.ServletRequest;
import jakarta.servlet.ServletResponse;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpSession;

import ru.bitel.bgbilling.kernel.contract.api.common.bean.Contract;

public class MyBGAufhFilter
    implements Filter
{
    @Override
    public void init( FilterConfig filterConfig )
        throws ServletException
    {
    }

    @Override
    public void doFilter( ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain )
        throws IOException, ServletException
    {
        HttpServletRequest request = (HttpServletRequest)servletRequest;
        
        boolean redirect = false;
        if ( !request.getServletPath().startsWith( "/jakarta.faces.resource/" ) )
        {
            redirect = redirectToLoginForm( request, servletResponse );
        }
        
        if ( !redirect )
        {
            filterChain.doFilter( servletRequest, servletResponse );
        }
    }

    private boolean redirectToLoginForm( HttpServletRequest request, ServletResponse servletResponse )
        throws ServletException, IOException
    {
        HttpSession session = request.getSession();
        Contract contract = (Contract)session.getAttribute( "mybgbilling.contract" );
        if ( contract == null )
        {
            if ( !request.getRequestURI().endsWith( "login.xhtml" ) 
                 && request.getParameter( "loginForm" ) == null )
            {
                request.getRequestDispatcher( "/login.xhtml" ).forward( request, servletResponse );
                return true;
            }
        }
        return false;
    }
    
    @Override
    public void destroy()
    {
    }
}
