/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.realm;

import java.io.IOException;
import java.io.Serializable;

import jakarta.enterprise.context.SessionScoped;
import jakarta.enterprise.event.Observes;
import jakarta.faces.context.ExternalContext;
import jakarta.faces.context.FacesContext;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.common.BGIllegalAccessException;
import ru.bitel.bgbilling.common.BGIllegalArgumentException;
import ru.bitel.bgbilling.common.BGMessageException;
import ru.bitel.bgbilling.kernel.contract.api.common.service.ContractService;
import ru.bitel.common.Utils;
import ru.bitel.mybgbilling.kernel.common.Configuration;
import ru.bitel.mybgbilling.kernel.common.UrlHandler.UrlEvent;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;
import ru.bitel.mybgbilling.kernel.ws.CustomerBean;
import ru.bitel.oss.kernel.entity.common.bean.EntityAttr;
import ru.bitel.oss.kernel.entity.common.bean.EntityAttrBoolean;
import ru.bitel.oss.kernel.entity.common.bean.EntitySpecAttrType;

@Named
@SessionScoped
@BGInjection
public class ConfirmUrlHandler
    implements
    Serializable
{
    @BGInject(module = false)
    private ContractService contractService;
    @Inject
    private Configuration configuration;
    /**
     * 
     */
    private static final long serialVersionUID = -1776636284019648342L;
    @Inject
    protected ConfirmBean confirmBean;
    @Inject
    protected CustomerBean customerBean;

    public void handle( @Observes UrlEvent e )
        throws IOException,
        BGIllegalArgumentException,
        BGMessageException,
        BGIllegalAccessException,
        BGException
    {
        if ( e.isStop() )
        {
            return;
        }
        if ( !confirmBean.isConfirm() )
        {
            //проверяем установлен ли параметр
            Object obj = configuration.get( "content.kernel.confirmParamId" );
            if ( obj == null )
            {
                return;
            }
            int pid = Utils.parseInt( obj.toString(), -1 );
            if ( pid < 0 )
            {
                return;
            }
            EntityAttr param = contractService.contractParameterGet( customerBean.getContractId(), pid );
            if ( param != null && ((EntityAttrBoolean)param).getValue() )
            {
                confirmBean.setConfirm( true );
            }
            else
            {
                FacesContext context = FacesContext.getCurrentInstance();
                ExternalContext ec = context.getExternalContext();
                ec.redirect( "confirm.xhtml" );
            }
        }
    }
}
